Index: src/Actions/Action_impl_pre.hpp
===================================================================
--- src/Actions/Action_impl_pre.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/Action_impl_pre.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,228 @@
+/*
+ * Action_impl.hpp
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+/** These macros define the following functions, necessary but repetitive for
+ * every Action:
+ *  -# Dialog* fillDialog()
+ *  -# action command (e.g. AnalysisMolecularVolume() )
+ *  -# void getParametersfromValuStorage()
+ *  -# struct Action...Parameters
+ *
+ *  For this, the user has the define the following values, each with
+ *  parenthesis, for the values/parameters the action needs
+ *  -# paramtypes, e.g. (int)(double)
+ *  -# paramtokens, e.g. ("Z")("length")
+ *  -# paramreferences, e.g. (Z)(length)
+ *  and for additional values/parameters to save in the state
+ *  -# statetypes, e.g. (int)(double)
+ *  -# statereferences, e.g. (Z)(length)
+ *  and the name and category of the action
+ *  -# CATEGORY, e.g. Analysis
+ *  -# ACTIONNAME, e.g. MolecularVolume
+ */
+
+
+#include <boost/preprocessor/cat.hpp>
+#include <boost/preprocessor/expand.hpp>
+#include <boost/preprocessor/comparison/equal.hpp>
+#include <boost/preprocessor/comparison/not_equal.hpp>
+#include <boost/preprocessor/control/if.hpp>
+#include <boost/preprocessor/debug/assert.hpp>
+#include <boost/preprocessor/iteration/local.hpp>
+#include <boost/preprocessor/punctuation/comma_if.hpp>
+#include <boost/preprocessor/repetition/repeat.hpp>
+#include <boost/preprocessor/seq/elem.hpp>
+#include <boost/preprocessor/seq/push_back.hpp>
+#include <boost/preprocessor/seq/seq.hpp>
+#include <boost/preprocessor/seq/size.hpp>
+#include <boost/preprocessor/seq/transform.hpp>
+
+// some derived names
+#define ACTION BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Action))
+#define COMMAND BOOST_PP_CAT(CATEGORY, ACTIONNAME)
+#define STATE BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, State))
+#define PARAMS BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Parameters))
+
+// check if no lists given
+#ifndef paramtypes
+#define MAXPARAMTYPES 0
+#else
+#define MAXPARAMTYPES BOOST_PP_SEQ_SIZE(paramtypes)
+#endif
+#ifndef statetypes
+#define MAXSTATETYPES 0
+#else
+#define MAXSTATETYPES BOOST_PP_SEQ_SIZE(statetypes)
+#endif
+
+// check user has given name and category
+#ifndef CATEGORY
+ERROR: No "CATEGORY" defined in: __FILE__
+#endif
+
+#ifndef ACTIONNAME
+ERROR: No "ACTIONNAME" defined in: __FILE__
+#endif
+
+// calculate numbers and check whether all have same size
+#ifdef paramtokens
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXPARAMTYPES, BOOST_PP_SEQ_SIZE(paramtokens)),\
+  ERROR: There are not the same number of "paramtokens" and "paramtypes" in: __FILE__ \
+)
+#endif
+#ifdef paramreferences
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXPARAMTYPES, BOOST_PP_SEQ_SIZE(paramreferences)),\
+  ERROR: There are not the same number of "paramtokens" and "paramreferences" in: __FILE__ \
+)
+#endif
+
+#ifdef statetypes
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXSTATETYPES, BOOST_PP_SEQ_SIZE(statereferences)),\
+  ERROR: There are not the same number of "statetypes" and "statereferences" in: __FILE__ \
+)
+#endif
+
+// print a list of type ref followed by a separator, i.e. "int i;"
+#define initialiser_print(z,n,initialiserlist) \
+  BOOST_PP_SEQ_ELEM(n, initialiserlist) \
+  (BOOST_PP_CAT(_, BOOST_PP_SEQ_ELEM(n, initialiserlist))),
+
+// print a list of ref(_ref) followed by a separator, i.e. "id(_id),"
+#define type_print(z,n,TYPELIST, VARLIST, separator) \
+  BOOST_PP_SEQ_ELEM(n, TYPELIST) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST)\
+  separator
+
+// print a list of type ref followed, i.e. "int i, double position"
+#define type_list(z,n,TYPELIST,VARLIST) \
+  BOOST_PP_COMMA_IF(n)\
+  BOOST_PP_SEQ_ELEM(n, TYPELIST) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST)
+
+// prints dialog->query calls for paramtypes with tokens
+#define dialog_print(z,n,unused) \
+  dialog->query<\
+  BOOST_PP_SEQ_ELEM(n, paramtypes)\
+  >(\
+  BOOST_PP_SEQ_ELEM(n, paramtokens)\
+  , ValueStorage::getInstance().getDescription(\
+  BOOST_PP_SEQ_ELEM(n, paramtokens)\
+  ));
+
+// prints set/queryCurrentValue (command) for paramreferences and paramtokens
+#define value_print(z,n,command, prefix) \
+  ValueStorage::getInstance(). command (\
+  BOOST_PP_SEQ_ELEM(n, paramtokens)\
+  , \
+  prefix\
+  BOOST_PP_SEQ_ELEM(n, paramreferences)\
+  );
+
+#include "Actions/ActionRegistry.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// =========== memento to remember the state when undoing ===========
+class STATE : public ActionState {
+public:
+  STATE(
+#if defined statetypes && defined statereferences // if we have parameters, we have to add "_" before each reference and add the params as the last one
+#define OP(s,data,elem) BOOST_PP_CAT(data, elem)  // OP to add "_"
+#define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, BOOST_PP_SEQ_PUSH_BACK(statetypes, const ACTION::PARAMS &), BOOST_PP_SEQ_TRANSFORM(OP, _, BOOST_PP_SEQ_PUSH_BACK(statereferences, params)))
+#else /// if not, params is only list
+#define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, (const ACTION::PARAMS &), (_params))
+#endif
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXSTATETYPES)
+#include BOOST_PP_LOCAL_ITERATE()
+) :
+#if defined statetypes && defined statereferences // do we have parameters at all?
+BOOST_PP_REPEAT(MAXSTATETYPES, initialiser_print, statereferences)
+#endif
+params(_params)
+  {}
+
+#if defined statetypes && defined statereferences // do we have parameters at all?
+#define BOOST_PP_LOCAL_MACRO(n) type_print(~, n, statetypes, statereferences, ;)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXSTATETYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+  ACTION::PARAMS params;
+};
+
+// =========== name of action ===========
+const char ACTION::NAME[] = TOKEN;
+
+// =========== constructor ===========
+ACTION::ACTION () :
+  Action(NAME)
+{}
+
+// =========== destructor ===========
+ACTION::~ACTION ()
+{}
+
+// =========== fill a dialog ===========
+Dialog* ACTION::fillDialog(Dialog *dialog) {
+        ASSERT(dialog,"No Dialog given when filling actionname's dialog");
+#if BOOST_PP_EQUAL(MAXPARAMTYPES,0)
+        dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+#else
+#define BOOST_PP_LOCAL_MACRO(n) dialog_print(~, n, ~)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+        return dialog;
+};
+
+// =========== command for calling action directly ===========
+#if defined paramtypes && defined paramreferences
+void COMMAND(
+#define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, paramtypes, paramreferences)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+)
+#else
+void COMMAND()
+#endif
+{
+  ACTION::PARAMS params;
+  Action *ToCall = ActionRegistry::getInstance().getActionByName( ACTION::NAME ); //->clone(params);
+#if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
+#define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, setCurrentValue, )
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+  ToCall->call(Action::NonInteractive);
+};
+
+// =========== obtain parameters from Storage, used by performCall() ===========
+void ACTION::getParametersfromValueStorage() {
+#if BOOST_PP_NOT_EQUAL(MAXPARAMTYPES,0)
+#define BOOST_PP_LOCAL_MACRO(n) value_print(~, n, queryCurrentValue, params.)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+#endif
+};
+
+// free up defines
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+#undef MAXPARAMTYPES
+#undef statetypes
+#undef statereferences
+#undef MAXSTATETYPES
+
+#undef ACTION
+#undef COMMAND
+#undef PARAMS
+#undef STATE
+
+#undef ACTIONNAME
+#undef CATEGORY
+#undef TOKEN
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MolecularVolumeAction.cpp
@@ -6,14 +13,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AnalysisAction/MolecularVolumeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "boundary.hpp"
 #include "config.hpp"
 #include "molecule.hpp"
 #include "linkedcell.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "tesselation.hpp"
 #include "World.hpp"
 
@@ -23,32 +34,14 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AnalysisAction/MolecularVolumeAction.hpp"
 
-const char AnalysisMolecularVolumeAction::NAME[] = "molecular-volume";
+// and construct the stuff
+#include "MolecularVolumeAction.def"
+#include "Action_impl_pre.hpp"
 
-AnalysisMolecularVolumeAction::AnalysisMolecularVolumeAction() :
-  Action(NAME)
-{}
-
-AnalysisMolecularVolumeAction::~AnalysisMolecularVolumeAction()
-{}
-
-void AnalysisMolecularVolume() {
-  ActionRegistry::getInstance().getActionByName(AnalysisMolecularVolumeAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog * AnalysisMolecularVolumeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+/** =========== define the function ====================== */
 Action::state_ptr AnalysisMolecularVolumeAction::performCall() {
-  int molID = -1;
   // obtain information
-  ValueStorage::getInstance().queryCurrentValue(NAME, molID);
+  getParametersfromValueStorage();
 
   // execute action
@@ -58,7 +51,7 @@
     const LinkedCell *LCList = NULL;
     DoLog(0) && (Log() << Verbose(0) << "Evaluating volume of the convex envelope.");
-    LCList = new LinkedCell(mol, 10.);
+    LCList = new LinkedCell(*mol, 10.);
     config * const configuration = World::getInstance().getConfig();
-    Boundaries *BoundaryPoints = NULL;
+    //Boundaries *BoundaryPoints = NULL;
     //FindConvexBorder(mol, BoundaryPoints, TesselStruct, LCList, argv[argptr]);
     FindNonConvexBorder(mol, TesselStruct, LCList, 5., NULL);
@@ -93,2 +86,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/MolecularVolumeAction.def
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,21 @@
+/*
+ * MolecularVolumeAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+//#define paramtypes (int)
+//#define paramreferences (molID)
+//#define paramtokens (NAME)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define ACTIONNAME MolecularVolume
+#define TOKEN "molecular-volume"
+
Index: src/Actions/AnalysisAction/MolecularVolumeAction.hpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,28 +9,13 @@
 #define MOLECULARVOLUMEACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Actions/Action.hpp"
 
-void AnalysisMolecularVolume();
-
-class AnalysisMolecularVolumeAction : public Action {
-  friend void AnalysisMolecularVolume();
-public:
-  AnalysisMolecularVolumeAction();
-  virtual ~AnalysisMolecularVolumeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "MolecularVolumeAction.def"
+#include "Actions/Action_impl_header.hpp"
 
 #endif /* MOLECULARVOLUMEACTION_HPP_ */
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PairCorrelationAction.cpp
@@ -6,17 +13,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AnalysisAction/PairCorrelationAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "analysis_correlation.hpp"
 #include "boundary.hpp"
 #include "linkedcell.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -26,79 +36,32 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AnalysisAction/PairCorrelationAction.hpp"
 
-const char AnalysisPairCorrelationAction::NAME[] = "pair-correlation";
+// and construct the stuff
+#include "PairCorrelationAction.def"
+#include "Action_impl_pre.hpp"
 
-AnalysisPairCorrelationAction::AnalysisPairCorrelationAction() :
-  Action(NAME)
-{}
-
-AnalysisPairCorrelationAction::~AnalysisPairCorrelationAction()
-{}
-
-void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, string &outputname, string &binoutputname, bool periodic) {
-  ValueStorage::getInstance().setCurrentValue("elements", elements);
-  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
-  ActionRegistry::getInstance().getActionByName(AnalysisPairCorrelationAction::NAME)->call(Action::NonInteractive);
-};
-
-
-Dialog* AnalysisPairCorrelationAction::fillDialog(Dialog* dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
-  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
-  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
-  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
-  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
-  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
-  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
-
-  return dialog;
-}
-
+/** =========== define the function ====================== */
 Action::state_ptr AnalysisPairCorrelationAction::performCall() {
   int ranges[3] = {1, 1, 1};
-  double BinEnd = 0.;
-  double BinStart = 0.;
-  double BinWidth = 0.;
-  molecule *Boundary = NULL;
-  string outputname;
-  string binoutputname;
-  bool periodic;
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
   string type;
-  Vector Point;
   BinPairMap *binmap = NULL;
 
   // obtain information
-  ValueStorage::getInstance().queryCurrentValue("elements", elements);
-  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
+  getParametersfromValueStorage();
 
   // execute action
-  output.open(outputname.c_str());
-  binoutput.open(binoutputname.c_str());
+  output.open(params.outputname.c_str());
+  binoutput.open(params.binoutputname.c_str());
   PairCorrelationMap *correlationmap = NULL;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
-  if (periodic)
-    correlationmap = PeriodicPairCorrelation(molecules, elements, ranges);
+  if (params.periodic)
+    correlationmap = PeriodicPairCorrelation(molecules, params.elements, ranges);
   else
-    correlationmap = PairCorrelation(molecules, elements);
+    correlationmap = PairCorrelation(molecules, params.elements);
   OutputPairCorrelation(&output, correlationmap);
-  binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
+  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
   OutputCorrelation ( &binoutput, binmap );
   delete(binmap);
@@ -128,2 +91,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/PairCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AnalysisAction/PairCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,23 @@
+/*
+ * PairCorrelationAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include <string>
+#include <vector>
+class element;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::vector<const element *>)(double)(double)(double)(std::string)(std::string)(bool)
+#define paramreferences (elements)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
+#define paramtokens ("elements")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define ACTIONNAME PairCorrelation
+#define TOKEN "pair-correlation"
Index: src/Actions/AnalysisAction/PairCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,31 +9,13 @@
 #define PAIRCORRELATIONACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Actions/Action.hpp"
-#include <string>
-#include <vector>
 
-class element;
-
-void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-
-class AnalysisPairCorrelationAction : public Action {
-  friend void AnalysisPairCorrelation(std::vector< element *> &elements, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-public:
-  AnalysisPairCorrelationAction();
-  virtual ~AnalysisPairCorrelationAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-   virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "PairCorrelationAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* PAIRCORRELATIONACTION_HPP_ */
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PointCorrelationAction.cpp
@@ -6,19 +13,23 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AnalysisAction/PointCorrelationAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "analysis_correlation.hpp"
 #include "boundary.hpp"
 #include "linkedcell.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
+#include <cmath>
 #include <iostream>
 #include <string>
@@ -26,84 +37,36 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AnalysisAction/PointCorrelationAction.hpp"
 
-const char AnalysisPointCorrelationAction::NAME[] = "point-correlation";
 
-AnalysisPointCorrelationAction::AnalysisPointCorrelationAction() :
-  Action(NAME)
-{}
+// and construct the stuff
+#include "PointCorrelationAction.def"
+#include "Action_impl_pre.hpp"
 
-AnalysisPointCorrelationAction::~AnalysisPointCorrelationAction()
-{}
-
-void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, string &outputname, string &binoutputname, bool periodic) {
-  ValueStorage::getInstance().setCurrentValue("elements", elements);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
-  ActionRegistry::getInstance().getActionByName(AnalysisPointCorrelationAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* AnalysisPointCorrelationAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
-  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
-  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
-  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
-  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
-  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
-  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
-  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
-
-  return dialog;
-}
-
+/** =========== define the function ====================== */
 Action::state_ptr AnalysisPointCorrelationAction::performCall() {
   int ranges[3] = {1, 1, 1};
-  double BinEnd = 0.;
-  double BinStart = 0.;
-  double BinWidth = 0.;
-  molecule *Boundary = NULL;
-  string outputname;
-  string binoutputname;
-  bool periodic;
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
   string type;
-  Vector Point;
   BinPairMap *binmap = NULL;
 
   // obtain information
-  ValueStorage::getInstance().queryCurrentValue("position", Point);
-  ValueStorage::getInstance().queryCurrentValue("elements", elements);
-  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
+  getParametersfromValueStorage();
 
   // execute action
-  output.open(outputname.c_str());
-  binoutput.open(binoutputname.c_str());
-  cout << "Point to correlate to is  " << Point << endl;
+  output.open(params.outputname.c_str());
+  binoutput.open(params.binoutputname.c_str());
+  cout << "Point to correlate to is  " << params.Point << endl;
   CorrelationToPointMap *correlationmap = NULL;
-  for(std::vector< element *>::iterator iter = elements.begin(); iter != elements.end(); ++iter)
-    cout << "element is " << (*iter)->symbol << endl;
+  for(std::vector<const element *>::iterator iter = params.elements.begin(); iter != params.elements.end(); ++iter)
+    cout << "element is " << (*iter)->getSymbol() << endl;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
-  if (periodic)
-    correlationmap  = PeriodicCorrelationToPoint(molecules, elements, &Point, ranges);
+  if (params.periodic)
+    correlationmap  = PeriodicCorrelationToPoint(molecules, params.elements, &params.Point, ranges);
   else
-    correlationmap = CorrelationToPoint(molecules, elements, &Point);
+    correlationmap = CorrelationToPoint(molecules, params.elements, &params.Point);
   OutputCorrelationToPoint(&output, correlationmap);
-  binmap = BinData( correlationmap, BinWidth, BinStart, BinEnd );
+  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
   OutputCorrelation ( &binoutput, binmap );
   delete(binmap);
@@ -133,2 +96,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/PointCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AnalysisAction/PointCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * PointCorrelationAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/Vector.hpp"
+#include <vector>
+#include <string>
+
+class element;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::vector<const element *>)(Vector)(double)(double)(double)(std::string)(std::string)(bool)
+#define paramreferences (elements)(Point)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
+#define paramtokens ("elements")("position")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define ACTIONNAME PointCorrelation
+#define TOKEN "point-correlation"
Index: src/Actions/AnalysisAction/PointCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,31 +9,13 @@
 #define POINTCORRELATIONACTION_HPP_
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Actions/Action.hpp"
-#include "vector.hpp"
 
-class element;
-
-void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-
-class AnalysisPointCorrelationAction : public Action {
-  friend void AnalysisPointCorrelation(std::vector< element *> &elements, Vector &position, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-
-public:
-  AnalysisPointCorrelationAction();
-  virtual ~AnalysisPointCorrelationAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "PointCorrelationAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* POINTCORRELATIONACTION_HPP_ */
